<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;
use App\Models\Mailer;

class RencontreController extends Controller
{
    public function script(){
        $query = "SELECT * FROM toulousains";
        $_results = DB::select( DB::raw($query));
        $id;
        foreach($_results as $i => $res){     
            $year = (int)explode('-',$res->date_inscription)[0] - $res->age ;
            $data = array(
                'pseudo' => $res->pseudo,
                'email' => $res->email,
                'sex' => $res->sexe,
                'password' => sha1($res->pass),
                'residence' => $res->residence,
                'birth_year' => $year,
                'about_me' => $res->vous,
                'looking_for' => $res->partenaire,
                'my_likes' => $res->aime1,
                'my_dislikes' => $res->aimepas1,
                'nb_visit' => $res->visites,
                'last_visit' => $res->date,
                'charte' => $res->charte,
                'created_date' => $res->date_inscription,
                'image' => $res->image,
                'thumbnail' => $res->image_petite,
                'ip_address' => $res->origine,
                'newsletter' => $res->alerte,
                'signe' => $res->signe,
                'status' => (strtolower($res->peut_entrer) == 'y' ? 1 : 0)
            );
            $id = DB::table('t_toulousains')->insert($data);
        }
    }

    public function script_courrier(){
        $query = "SELECT c.* , t1.id as id_s, t2.id as id_r FROM courrier as c LEFT JOIN t_toulousains as t1 ON t1.pseudo = c.auteur LEFT JOIN t_toulousains as t2 ON t2.pseudo = c.destinataire";
        $_results = DB::select( DB::raw($query));
        foreach($_results as $i => $res){  
            $r = 0;
            if($res->suppemis == 'x' && $res->supprecus == 'x')
                $r = 3;
            else if ($res->suppemis == 'x')
                $r = 1;
            else if ($res->supprecus == 'x')
                $r = 2;

            $data = array(
                'id_sender'	    => $res->id_s,
                'id_receiver'	=> $res->id_r,
                'title'	        => $res->titre,
                'body'	        => $res->message,
                'date_sent'	    => $res->date,
                'removed_by'	=> $r,
                'ip_address'    => $res->origine,
                'is_seen'       => ($res->statut == 'lu') ? 1 : 0
            );
            $id = DB::table('t_courriers')->insert($data);
        }
    }

    public function nb_actif(){
        $query = "SELECT count(*) as nb FROM t_toulousains WHERE status = 1"; 
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function nb_connection($is_today=true){
        /*$ip = \Request::getClientIp(true);
        print_r($ip);*/
        $now = new \DateTime();
        if(!$is_today)
            $now = $now-> modify('-1 day');
        $m = $now->format('m');
        $y=  $now->format('Y');
        $d =  $now->format('d');

        $query = "SELECT count(*) as nb FROM t_nbconnections WHERE DATE_FORMAT(date_connection, '%Y') = '".$y."' AND DATE_FORMAT(date_connection, '%m') = '".$m."'  AND DATE_FORMAT(date_connection, '%d') = '".$d."'  "; 
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function last_connected(){
        $query = "SELECT DATE_FORMAT(con.date_connection, '%h:%i') as hour ,toulou.pseudo as pseudo, toulou.birth_year,toulou.residence, toulou.sex from t_nbconnections as con LEFT JOIN t_toulousains as toulou ON toulou.id = con.id_toulousain order by con.id desc limit 30";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function last_registred(){
        $query = "SELECT pseudo,birth_year,residence,created_date ,sex from t_toulousains where status = 1 order by id desc limit 25 ";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function check(Request $request){
        $key = $request->input('key');
        $val = $request->input($key);
        $query = "SELECT count(id) as nb FROM t_toulousains WHERE ".$key."='".$val."'";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function registration(Request $request){
        $data = json_decode($request->input('data'),true);
        $now = new \DateTime(); 
        $data['birth_year'] = (int)$now->format('Y') - (int)$data['birth_year'];
        $sorties = $data['sorties'];
        unset($data['sorties']);
        $data['password'] = sha1($this->randomCodde());
        $id = DB::table('t_toulousains')->insertGetId($data);
        foreach($sorties as $s){
            $_data = array(
                'id_toulousain' => $id,
                'id_type_sortie' => $s
            );
            DB::table('t_alert_sorties')->insertGetId($_data);
        }
        Mailer::registration($data);
        return $data;
    }

    public function updatealert(Request $request){
        $data = json_decode($request->input('data'),true);
        $sorties = $data['alerts'];
        unset($data['alerts']);
        $id = $data['id_toulousain'];
        unset($data['id_toulousain']);
        DB::table('t_toulousains')->where('id', $id)->update($data);
        DB::table('t_alert_sorties')->delete(['id_toulousain' => $id]);
        foreach($sorties as $s){
            $data = array(
                'id_toulousain' => $id,
                'id_type_sortie' => $s
            );
            DB::table('t_alert_sorties')->insertGetId($data);
        }
        return $data;
    }

    public function validate_account(Request $request){
        $email = base64_decode($request->input('token'));
        $data = array();
        $mdp = $this->randomCodde();
        $data['status'] = 1;
        $data['password'] = sha1($mdp);
        $affected = DB::table('t_toulousains')
              ->where('email', $email)
              ->update($data);
        $domaine = Mailer::validation($email, $mdp);
        header('Location:' . $domaine . 'rencontres_validation');
        die();
    }

    public function updateProfile(Request $request){
        $data = json_decode($request->input('data'),true);
        $now = new \DateTime(); 
        $data['birth_year'] = (int)$now->format('Y') - (int)$data['age'];
        unset($data['sorties']);
        if(isset($data['password']))
            $data['password'] = sha1($data['password']);
        $id = $data['id'];
        unset($data['id']);
        unset($data['age']);

        $affected = DB::table('t_toulousains')
              ->where('id', $id)
              ->update($data);
        return $affected;
    }

    public function online(){
        $now = new \DateTime(); 
        $now = $now-> modify('-15 minutes');
        $now = $now->format('Y').'-'.$now->format('M').'-'.$now->format('D').' '.$now->format('h').':'.$now->format('i');
        $query = "SELECT con.date_connection as hour ,toulou.pseudo as pseudo, toulou.birth_year,toulou.residence, toulou.sex from t_nbconnections  as con LEFT JOIN t_toulousains as toulou ON toulou.id = con.id_toulousain WHERE date_connection >= '".$now."' GROUP BY toulou.pseudo order by con.date_connection desc limit 30";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    private function randomCodde(){
        $digits = 6;
        return str_pad(rand(0, pow(10, $digits)-1), $digits, '0', STR_PAD_LEFT);
    }

    public function login(Request $request){
        $data = json_decode($request->input('data'));

        $data->password = sha1($data->password);

        $query = " SELECT id, pseudo FROM t_toulousains WHERE email='".$data->pseudo."' AND password='".$data->password."' ";
        $results = DB::select(DB::raw($query));
        if(count($results) > 0){
            $q = array(
                'id_toulousain' => $results[0]->id,
                'ip_address' => '127.0.0.1'
            );
            DB::table('t_nbconnections')->insert($q);
        };
        return $results;
    }

    public function forget(Request $request){
        $pseudo = $request->input('pseudo');
        $data = DB::table('email_validation')->where('pseudo', $pseudo)->first();
        $code = $this->randomCodde();
        $hash = sha1($code);
        $data = array('pseudo'=>$pseudo, 'code'=> $code, 'hash'=>$hash);
        DB::table('email_validation')->where('pseudo', $pseudo)->delete();
        DB::table('email_validation')->insert($data);
        //Mailer::resetPassword($data);

        Mailer::validation($pseudo, $code);

        
        DB::table('t_toulousains')->where('email', $pseudo)->update(array('password' => $hash));
        
        header("Location: https://toulouseweb.com/rencontres_validation");
        exit();
        
        return array();
    }

    public function validation(Request $request){

        $pseudo = $request->input('pseudo');
        $hash = $request->input('code');

        $val = DB::table('email_validation')->where('pseudo', $pseudo)->where('hash', $hash)->first();

        if(!$val){
            header("Location: https://toulouseweb.com/invalid");
            exit();
        }

        $now = new \DateTime("now");
        $end_validity = new \DateTime($val->end_validity);   

        $left_time = $end_validity->getTimestamp() - $now->getTimestamp();
        if($left_time < 0){
            header("Location: https://toulouseweb.com/invalid");
            exit();
        }
        
        Mailer::validation($pseudo, $val->code);

        
        DB::table('t_toulousains')->where('email', $pseudo)->update(array('password' => $hash));
        
        header("Location: https://toulouseweb.com/rencontres_validation");
        exit();
        
        
    }

    public function setPassword(Request $request){
        $data = json_decode($request->input('data'));
        
        $data->password = sha1($data->password);
        $data = (array)$data;
        return DB::table('t_toulousains')->where('pseudo', $data['pseudo'])->update(array('password' => $data['password']));
    }

    public function serachBy(Request $request){
        $data = json_decode($request->input('data'));
        $now = new \DateTime(); 
        $year = (int)$now->format('Y');
        $sex = $data->sex;
        $age1 = $year - (int)$data->age1;
        $age2 = $year - (int)$data->age2;
        $name = $data->name;
        $where = "toulou.sex = '".$sex."'";
        if(isset($name) && !empty($name))
            $where .=" AND toulou.pseudo LIKE '%".$name."%'";
        if(isset($age2) && isset($age1))
            $where .=" AND (toulou.birth_year BETWEEN ".$age2." AND ".$age1.") ";
        $query = "SELECT con.date_connection as last_visit ,toulou.pseudo as pseudo, toulou.birth_year,toulou.residence, SUBSTRING(toulou.about_me, 1, 100)  as profil FROM t_toulousains as toulou LEFT JOIN t_nbconnections  as con ON toulou.id = con.id_toulousain WHERE ".$where." GROUP BY toulou.pseudo order by con.date_connection desc";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function serachByName(Request $request){
        $data = json_decode($request->input('data'));
        $now = new \DateTime(); 
        $year = (int)$now->format('Y');
        $sex = $data->sex;
        $name = $data->name;
        $where = "toulou.sex = '".$sex."'";
        if(isset($name) && !empty($name))
            $where .=" AND toulou.pseudo LIKE '".$name."%'";

        $query = "SELECT con.date_connection as last_visit ,toulou.pseudo as pseudo, toulou.birth_year,toulou.residence, SUBSTRING(toulou.about_me, 1, 100)  as profil FROM t_toulousains as toulou LEFT JOIN t_nbconnections  as con ON toulou.id = con.id_toulousain WHERE ".$where." GROUP BY toulou.pseudo order by con.date_connection desc";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function my_profile($id){
        $query = "SELECT * FROM t_toulousains WHERE id ='".$id."'";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function bypseudo($id){
        $query = "SELECT t.*, con.date_connection as last_connection, CONCAT('[',GROUP_CONCAT(cda.note ORDER BY cda.note  DESC),']') as notes FROM t_toulousains as t LEFT JOIN t_cote_d_amour as cda ON cda.id_for = t.id LEFT JOIN t_nbconnections  as con ON t.id = con.id_toulousain WHERE t.pseudo ='".$id."' GROUP BY cda.id_for";
        $results = DB::select(DB::raw($query));
        $results = array_map(function($d){
            $d->notes = json_decode($d->notes);
            return $d;
        }, $results);
        return $results;
    }

    public function add_visitor(Request $request){
        $data = json_decode($request->input('data'), true);
        DB::table('t_toulousains')
            ->where('id', $data['id_toulousain'])
            ->update(['last_visit' => date("Y-m-d")]);
        return DB::table('t_nb_visites')->insertGetId($data);
    }

    public function visitors($id = null){
        $now = new \DateTime(); 
        $y = (int)$now->format('Y');
        $m = (int)$now->format('m');
        $d = (int)$now->format('d');
        $results = DB::table('t_nb_visites')
            ->join('t_toulousains','t_toulousains.id','=','t_nb_visites.id_toulousain')
            ->select('t_toulousains.pseudo as pseudo','t_toulousains.sex',DB::raw("COUNT(t_nb_visites.id) as nb"))            
            //->where('id_toulousain', $id)
            ->where(DB::raw("(DATE_FORMAT(date_visite,'%Y'))"), $y)
            ->where(DB::raw("(DATE_FORMAT(date_visite,'%m'))"), $m)
            ->where(DB::raw("(DATE_FORMAT(date_visite,'%d'))"), $d)
            ->groupBy('id_toulousain')
            ->orderBy('nb', 'desc')
            ->get();
        return $results;
    }

    public function galeries(){
        $results = array();
        $cdir = scandir(public_path().'/galeries');           

        foreach ($cdir as $key => $value){
            if(!strpos($value, '.gif'))
                continue;
            if (!array_key_exists($value[0], $results))
                $results[$value[0]] = array();

            array_push($results[$value[0]], array('img' => 'galeries/'.$value));
        }

        return $results;
    }

    public function setImg(Request $request){
        $data = json_decode($request->input('data'), true);
       return  DB::table('t_toulousains')->where('id', $data['id'])->update(['image' => $data['image']]);
    }
}