<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DB;

class AgendaController extends Controller
{

    public function getCategory($cat){
        return (array)DB::table('t_agenda_categories')->select('id', 'name')->where('libelle', $cat)->first();
    }
    public function formatData(){
        //	id_area	title	sub_title	description	price	style	image	sart_date	end_date	schedule	status	created_date	
        $query = "SELECT s.id as id_area, e.titre as title, e.soustitre as sub_title, e.texte as description, e.style as style, 
            e.image as image, a.laps as sart_end_date, a.date as created_date, a.horaire as schedule, a.prix as price, 
            CASE WHEN a.valid = 'v' THEN 1 ELSE 0 END as status,
         GROUP_CONCAT(DISTINCT e.genre) as categories FROM agenda as a LEFT JOIN events as e ON a.titre = e.titre LEFT JOIN t_areas as s ON s.acronym = a.salle GROUP BY e.titre, e.texte ORDER BY a.date ASC";

        $_results = DB::select( DB::raw($query) );

        foreach($_results as $r => $res){
            $sart_end_date = explode(">", $res->sart_end_date);
            unset($res->sart_end_date);
            $categories = explode(',', $res->categories);
            unset($res->categories);
            $date = $res->created_date;
            $res = (array)$res;
            
            $res['start_date'] = $this->formatDate((isset($sart_end_date[0]) && !empty(trim($sart_end_date[0]))) ? $sart_end_date[0] : $date);
            $res['end_date'] = $this->formatDate((isset($sart_end_date[1]) && !empty(trim($sart_end_date[1]))) ? $sart_end_date[1] : $date);            

            $id = DB::table('t_agendas')->insertGetId($res);

            foreach($categories as $c => $cat){
                $cat= trim($cat);
                echo $cat."-";
                if(strlen($cat) == 0)
                    continue;

                $q= "SELECT id FROM t_agenda_categories WHERE name like '%".$cat."%'";
                $id_cat = DB::select( DB::raw($q));
                if(count($id_cat) > 0){
                    $id_cat = $id_cat[0]->id;
                    echo $id_cat."-".$id."<br>";
                    $agenda_cat = array('id_agenda' => $id, 'id_agenda_category' => $id_cat);
                    DB::table('t_agenda_cat')->insert($agenda_cat);
                }
                
            }
        }
    }

    private function formatDate($date){
        $date = str_replace('/', '-', $date);
        return date('Y-m-d', strtotime($date));
    }

    public function getBydate($date){
        $date = $this->formatDate($date);
        $query = "SELECT CONCAT('[',GROUP_CONCAT('{ \"bg_color\" : \"',COALESCE(c.bg_color,''),'\",\"icon\" : \"',COALESCE(c.icon,''),'\", \"color\" : \"',c.color,'\", \"name\" : \"',c.name, '\"}'),']') as categories, CONCAT('{ \"address\" : \"',COALESCE(s.address,''),'\", \"description\" : \"',COALESCE(s.description,''),'\", \"web\" : \"',COALESCE(s.web_site,''),'\", \"phone\" : \"', COALESCE(s.phone,''), '\", \"name\" : \"', COALESCE(s.name,''), '\",\"acro\" : \"',COALESCE(s.acronym,''), '\"}') as area, a.title, a.id ,a.sub_title, a.description, a.price, a.style, a.image, a.start_date, a.end_date, a.schedule FROM t_agendas as a LEFT JOIN t_agenda_cat as ca ON ca.id_agenda = a.id LEFT JOIN t_agenda_categories as c ON c.id = ca.id_agenda_category LEFT JOIN t_areas as s ON s.id = a.id_area WHERE '".$date."' BETWEEN a.start_date AND a.end_date AND a.status = 1 GROUP BY a.id ORDER BY a.end_date ASC";
        $results = DB::select(DB::raw($query));
        return array_map(function($element) {
                $element->categories = json_decode($element->categories, true);
                $element->area = preg_replace("/[\n\r]/", "", $element->area);
                $element->area = json_decode($element->area, true);
                return $element;
            },
            $results
        );
    }

    public function getByCategory($id_cat){
        $date = $this->formatDate(date("Y/m/d"));
        $query = "SELECT CONCAT('[',GROUP_CONCAT('{ \"bg_color\" : \"',COALESCE(c.bg_color,''),'\",\"icon\" : \"',COALESCE(c.icon,''),'\", \"color\" : \"',c.color,'\", \"name\" : \"',c.name, '\", \"libelle\" : \"',c.libelle, '\"}'),']') as categories, CONCAT('{ \"address\" : \"',COALESCE(s.address,''),'\", \"description\" : \"',COALESCE(s.description,''),'\", \"web\" : \"',COALESCE(s.web_site,''),'\", \"phone\" : \"', COALESCE(s.phone,''), '\", \"name\" : \"', COALESCE(s.name,''), '\",\"acro\" : \"',COALESCE(s.acronym,''), '\"}') as area, a.title, a.id ,a.sub_title, a.description, a.price, a.style, a.image, a.start_date, a.end_date, a.schedule FROM t_agendas as a LEFT JOIN t_agenda_cat as ca ON ca.id_agenda = a.id LEFT JOIN t_agenda_categories as c ON c.id = ca.id_agenda_category LEFT JOIN t_areas as s ON s.id = a.id_area WHERE '".$date."' BETWEEN a.start_date AND a.end_date AND c.id = '".$id_cat."' AND a.status = 1 GROUP BY a.id ORDER BY a.end_date ASC";
        $results = DB::select(DB::raw($query));
        return array_map(function($element) {
                $element->categories = json_decode($element->categories, true);
                $element->area = preg_replace("/[\n\r]/", "", $element->area);
                $element->area = json_decode($element->area, true);
                return $element;
            },
            $results
        );
    }

    public function getById($id){
        $id = explode(':',base64_decode($id));
        if(count($id)>1){
            $id = $id[0];
        }else    
            $id = 0;

        $query = "SELECT CONCAT('[',GROUP_CONCAT('{ \"bg_color\" : \"',COALESCE(c.bg_color,''),'\",\"icon\" : \"',COALESCE(c.icon,''),'\", \"color\" : \"',c.color,'\", \"name\" : \"',c.name, '\", \"libelle\" : \"',c.libelle, '\"}'),']') as categories, CONCAT('{ \"address\" : \"',COALESCE(s.address,''),'\", \"description\" : \"',COALESCE(s.description,''),'\", \"web\" : \"',COALESCE(s.web_site,''),'\", \"phone\" : \"', COALESCE(s.phone,''), '\", \"name\" : \"', COALESCE(s.name,''), '\",\"acro\" : \"',COALESCE(s.acronym,''), '\"}') as area, a.title, a.id ,a.sub_title, a.description, a.price, a.style, a.image, a.start_date, a.end_date, a.schedule FROM t_agendas as a LEFT JOIN t_agenda_cat as ca ON ca.id_agenda = a.id LEFT JOIN t_agenda_categories as c ON c.id = ca.id_agenda_category LEFT JOIN t_areas as s ON s.id = a.id_area WHERE a.id = '".$id."' AND a.status = 1 GROUP BY a.id ORDER BY a.end_date ASC";
        $results = DB::select(DB::raw($query));
        return array_map(function($element) {
                $element->categories = json_decode($element->categories, true);
                $element->area = preg_replace("/[\n\r]/", "", $element->area);
                $element->area = json_decode($element->area, true);
                return $element;
            },
            $results
        );
    }

    public function search($val){
        $date = $this->formatDate(date("Y/m/d"));
        $query = "SELECT CONCAT('[',GROUP_CONCAT('{ \"bg_color\" : \"',COALESCE(c.bg_color,''),'\",\"icon\" : \"',COALESCE(c.icon,''),'\", \"color\" : \"',c.color,'\", \"name\" : \"',c.name, '\", \"libelle\" : \"',c.libelle, '\"}'),']') as categories, CONCAT('{ \"address\" : \"',COALESCE(s.address,''),'\", \"description\" : \"',COALESCE(s.description,''),'\", \"web\" : \"',COALESCE(s.web_site,''),'\", \"phone\" : \"', COALESCE(s.phone,''), '\", \"name\" : \"', COALESCE(s.name,''), '\",\"acro\" : \"',COALESCE(s.acronym,''), '\"}') as area, COALESCE(a.title,a.sub_title) as title , a.id ,a.sub_title, a.description, a.price, a.style, a.image, a.start_date, a.end_date, a.schedule FROM t_agendas as a LEFT JOIN t_agenda_cat as ca ON ca.id_agenda = a.id LEFT JOIN t_agenda_categories as c ON c.id = ca.id_agenda_category LEFT JOIN t_areas as s ON s.id = a.id_area WHERE (a.title LIKE '%".$val."%' OR a.description LIKE '%".$val."%' OR a.sub_title LIKE '%".$val."%') AND a.status = 1 GROUP BY a.id  ORDER BY a.end_date DESC LIMIT 50 ";
        $results = DB::select(DB::raw($query));
        return array_map(function($element) {
                $element->categories = json_decode($element->categories, true);
                $element->area = preg_replace("/[\n\r]/", "", $element->area);
                $element->area = json_decode($element->area, true);                   
                return $element;
            },
            $results
        );
    }
    
    public function categories(){
        $query = "SELECT id, name, color, libelle FROM t_agenda_categories WHERE status = 1 ORDER BY display_order, name ASC";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function areas(){
        $query = "SELECT name, id FROM t_areas GROUP BY name ORDER BY name ASC";
        $results = DB::select(DB::raw($query));
        return $results;
    }

    public function add(Request $request){
        $agenda = json_decode($request->input('data'));

        $categories = $agenda->categories;

        unset($agenda->categories);
        /*unset($agenda->name);
        unset($agenda->fname);
        unset($agenda->email);*/
        $agenda= (array) $agenda;
        $id = DB::table('t_agendas')->insertGetId($agenda);

        foreach($categories as $c){
            $d = array(
                'id_agenda_category' => $c,
                'id_agenda' => $id
            );
            $id = DB::table('t_agenda_cat')->insertGetId($d);

        }
        return $agenda;
    }
}