<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
//use Illuminate\Support\Facades\Request;
use DB;

class CinemaController extends Controller
{
    /**
     * Handle the incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function __invoke(Request $request)
    {
        //
    }

    public function wLogs($data)
    {
        $logPath = "logs.txt";
        $mode = (!file_exists($logPath)) ? 'w':'a';
        $logfile = fopen($logPath, $mode);
        fwrite($logfile, "\r\n". $data);
        fclose($logfile);
    }

    public function getCine($idCategCine, $idCine)
    {
        $where = "";

        if ($idCategCine != 0 && $where == ""){
            $where .= " where id_cine_categ = " . $idCategCine;
        } else if ($idCategCine != 0 && $where != ""){
            $where .= " and id_cine_categ = " . $idCategCine;
        }

        if ($idCine != 0 && $where == ""){
            $where .= " where id = " . $idCine;
        } else if ($idCine != 0 && $where != ""){
            $where .= " and id = " . $idCine;
        }


        $sql = "select * from t_cine" . $where . " order by nom asc";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }


    public function getCineBySlug($idCategCine, $slug)
    {
        $where = "";

        if ($idCategCine != 0 && $where == ""){
            $where .= " where id_cine_categ = " . $idCategCine;
        } else if ($idCategCine != 0 && $where != ""){
            $where .= " and id_cine_categ = " . $idCategCine;
        }

        if ($slug && $where == ""){
            $where .= " where slug = '" . $slug . "'";
        } else if ($slug != 0 && $where != ""){
            $where .= " and slug = '" . $slug . "'";
        }


        $sql = "select * from t_cine" . $where . " order by nom asc";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }


    public function getFilmsByCine($idCine, $datedeb, $datefin)
    {
        $sql = "SELECT cf.*, cp.start_date as date, cp.monday, cp.tuesday, cp.wednesday, cp.thursday, cp.friday,cp.saturday, cp.sunday, cp.avant_premiere, cl.langue, GROUP_CONCAT(ctp.type) as type
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                WHERE
                    cp.id_cine = " . $idCine . " and cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "'
                GROUP BY cp.id, cp.start_date
                ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmsByCineSlug($salleSlug, $datedeb, $datefin)
    {
        $sql = "SELECT cf.*, c.slug as salleSlug, cp.start_date as date, cp.monday, cp.tuesday, cp.wednesday, cp.thursday, cp.friday,cp.saturday, cp.sunday, cp.avant_premiere, cl.langue, GROUP_CONCAT(ctp.type) as type,
                (select count(*) from t_cine_comment cc where cc.id_cine_film = cf.id and cc.status = 1) as nbComment
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                    LEFT JOIN t_cine c on cp.id_cine = c.id
                WHERE
                    c.slug = '" . $salleSlug . "' and 
                    ((
                        ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                        or 
                        ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                    )
                        or (
                        (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                            and 
                            (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                        )
                    )
                GROUP BY cf.id
                ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmDetail($idFilm)
    {
        $sql = "SELECT cf.*, cp.start_date as date, cp.monday, cp.tuesday, cp.wednesday, cp.thursday, cp.friday,cp.saturday, cp.sunday, cp.avant_premiere, cl.langue, GROUP_CONCAT(ctp.type) as type
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                WHERE
                    cf.id = " . $idFilm . "
                GROUP BY cp.id,cp.start_date
                ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmDetailBySlug($filmSlug)
    {
        $sql = "SELECT cf.*, cp.start_date as date, cp.monday, cp.tuesday, cp.wednesday, cp.thursday, cp.friday,cp.saturday, cp.sunday, cp.avant_premiere, cl.langue, GROUP_CONCAT(ctp.type) as type, cf.slug
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                WHERE
                    cf.slug = '" . $filmSlug . "'
                GROUP BY cp.id, cp.start_date
                ORDER BY cp.start_date ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function searchFilm($filmToSearch)
    {
        $sql = "SELECT count(c.id_cine_film) as nbComment, f.id, f.titre, f.slug
        FROM `t_cine_film` f
        LEFT JOIN t_cine_comment c on f.id = c.id_cine_film
        WHERE lower(f.titre) like '%" . $filmToSearch . "%'
        GROUP BY c.id_cine_film
        ORDER BY f.titre";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmCommentsBySlug($filmSlug)
    {
        $sql = "SELECT 
					CONCAT('[', GROUP_CONCAT(concat('{\"comment\":\"', REPLACE(REPLACE(REPLACE(c.commentaire,'\n',' '),'\r',' '), '\"', ''), '\", \"date\":\"', c.date, '\", \"pseudo\":\"', c.pseudo, '\"}') SEPARATOR ','), ']') as comments, f.id, f.titre, f.slug, f.realisateur, f.synopsis 
				FROM t_cine_film f 
				LEFT JOIN (select * from t_cine_comment where status = 1) c on f.id = c.id_cine_film 
				WHERE f.slug = '" . $filmSlug . "'
				GROUP BY c.id_cine_film 
				ORDER BY f.titre";

        $results = DB::select( DB::raw($sql) );

        if (count($results) > 0){
            $comments = $results[0]->comments;
            $results[0]->comments = str_replace("\\","", $comments);
        }

        return $results;
    }

    public function addComment(Request $request)
    {
        $data = $request->input('data');

        $data = (array) json_decode($data);

        DB::table('t_cine_comment')->insert($data);
        $id = DB::getPdo()->lastInsertId();

        return $id;
    }

    public function getFilmPlusCommenter()
    {
        $sql = "SELECT count(cc.id_cine_film) as nbComment, cf.id,cf.titre,cf.slug FROM t_cine_film cf
                LEFT JOIN t_cine_comment cc on cf.id = cc.id_cine_film
                where cc.status = 1
                GROUP BY cc.id_cine_film
                HAVING count(cc.id_cine_film) > 0
                ORDER BY nbComment DESC
                LIMIT 5";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmsPanorama($datedeb, $datefin)
    {
        $sql = "SELECT cf.*, c.slug as salleSlug
                FROM t_cine_film cf
                    LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                    LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                    LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                    LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                    LEFT JOIN t_cine c on cp.id_cine = c.id
                WHERE
                    ((
                        ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                        or 
                        ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                    )
                        or (
                        (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                            and 
                            (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                        )
                    )
                GROUP BY cf.id
                ORDER BY cf.titre ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getFilmsPanoramaSalles($filmSlug, $datedeb, $datefin)
    {
        $sql = "SELECT cf.slug, cf.titre, GROUP_CONCAT(ctp.type) as type, c.slug as salleSlug, c.nom as salleNom, c.adresse as salleAdresse, c.cp as salleCP, c.ville as salleVille, cp.monday, cp.tuesday, cp.wednesday, cp.thursday, cp.friday, cp.saturday, cp.sunday, cp.avant_premiere
            FROM t_cine_film cf
                LEFT JOIN t_cine_projection cp on cf.id = cp.id_cine_film
                LEFT JOIN t_cine_lang cl on cp.id_cine_lang = cl.id
                LEFT JOIN t_cine_proj_types cpt on cp.id = cpt.id_proj
                LEFT JOIN t_cine_type_projection ctp on cpt.id_type = ctp.id
                LEFT JOIN t_cine c on cp.id_cine = c.id
            WHERE
                cf.slug = '" . $filmSlug . "' and
                ((
                    ('" . $datedeb . "' >= cp.start_date and '" . $datedeb . "' <=  cp.end_date)
                    or 
                    ('" . $datefin . "' >= cp.start_date and '" . $datefin . "' <= cp.end_date)
                )
                    or (
                    (cp.start_date >= '" . $datedeb . "' and cp.start_date <= '" . $datefin . "') 
                        and 
                        (cp.end_date >= '" . $datedeb . "' and cp.end_date <= '" . $datefin . "')
                    )
                )
            GROUP BY cp.id
            ORDER BY cf.titre ASC";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

    public function getAvantPremiere()
    {
        $sql = "select cf.titre, cf.slug from 
                t_cine_film cf
                inner join t_cine_projection cp on cf.id = cp.id_cine_film
                 where cp.avant_premiere = 1
                 group by cf.slug
                 order by cp.id
                LIMIT 5";

        $results = DB::select( DB::raw($sql) );

        return $results;
    }

}
